package org.jwat.tools;

import java.io.File;
import java.io.IOException;

import javax.xml.XMLConstants;
import javax.xml.transform.sax.SAXSource;
import javax.xml.validation.Schema;
import javax.xml.validation.SchemaFactory;
import javax.xml.validation.Validator;

import org.jwat.common.ContentType;
import org.jwat.common.Payload;
import org.jwat.warc.WarcRecord;
import org.w3c.dom.ls.LSInput;
import org.w3c.dom.ls.LSResourceResolver;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;

public class TestXmlValidator {

    private static SchemaFactory schemaFactory = SchemaFactory.newInstance(XMLConstants.W3C_XML_SCHEMA_NS_URI);

    /** The schema loaded from the XSD file. */
    private static Schema schema;

    static {
        try {
			LSResourceResolver resourceResolver = new MyResourceResolver();
			schemaFactory.setResourceResolver(resourceResolver);
			schema = schemaFactory.newSchema();
		}
        catch (SAXException e) {
			e.printStackTrace();
		}
    }

    public static class MyResourceResolver implements LSResourceResolver {
		@Override
		public LSInput resolveResource(String arg0, String arg1, String arg2,
				String arg3, String arg4) {
			System.out.println(arg0);
			System.out.println(arg1);
			System.out.println(arg2);
			System.out.println(arg3);
			System.out.println(arg4);
			return null;
		}
    }

    public static void validate_payload(WarcRecord warcRecord, ContentType contentType, Payload payload) {
    	if (contentType != null
    			&& "text".equalsIgnoreCase(contentType.contentType)
    			&& "xml".equalsIgnoreCase(contentType.mediaType)) {
            try {
                Validator schemaValidator = schema.newValidator();
    			LSResourceResolver resourceResolver = new MyResourceResolver();
                schemaValidator.setResourceResolver(resourceResolver);
                schemaValidator.setFeature("http://apache.org/xml/features/honour-all-schemaLocations", true);
            	System.out.println("Validating METS...");
    			schemaValidator.validate(new SAXSource(new InputSource(payload.getInputStream())));
    		}
            catch (SAXException e) {
    			// TODO Auto-generated catch block
    			e.printStackTrace();
    		}
            catch (IOException e) {
    			// TODO Auto-generated catch block
    			e.printStackTrace();
    		}
    	}
    	if ("metadata".equalsIgnoreCase("...")
    			&&contentType != null
    			&& "text".equalsIgnoreCase(contentType.contentType)
    			&& "xml".equalsIgnoreCase(contentType.mediaType)) {
        	initSchema(new File("kb.xsd"));
            Validator schemaValidator = schema.newValidator();
            try {
            	System.out.println("Validating METS...");
    			schemaValidator.validate(new SAXSource(new InputSource(payload.getInputStream())));
    		}
            catch (SAXException e) {
    			// TODO Auto-generated catch block
    			e.printStackTrace();
    		}
            catch (IOException e) {
    			// TODO Auto-generated catch block
    			e.printStackTrace();
    		}
    	}
    }

    private static void initSchema(File xsdFile) {
        SchemaFactory schemaFactory = SchemaFactory.newInstance(XMLConstants.W3C_XML_SCHEMA_NS_URI);
        try {
            schema = schemaFactory.newSchema(xsdFile);
        } catch (SAXException e) {
            throw new IllegalArgumentException("Unable to parse schema " + xsdFile, e);
        }
    }

    public static void validate_payload(String recordType, ContentType contentType, Payload payload) {
    	if ("metadata".equalsIgnoreCase(recordType)
    			&&contentType != null
    			&& "text".equalsIgnoreCase(contentType.contentType)
    			&& "xml".equalsIgnoreCase(contentType.mediaType)) {
        	initSchema(new File("kb.xsd"));
            Validator schemaValidator = schema.newValidator();
            try {
            	System.out.println("Validating METS...");
    			schemaValidator.validate(new SAXSource(new InputSource(payload.getInputStream())));
    		}
            catch (SAXException e) {
    			// TODO Auto-generated catch block
    			e.printStackTrace();
    		}
            catch (IOException e) {
    			// TODO Auto-generated catch block
    			e.printStackTrace();
    		}
    	}
    }

}
